      implicit double precision(a-h,o-z)
      dimension arraysigma(:),array(:)
      allocatable arraysigma,array
      save arraysigma,array
      character*100 process,process1
      character*1 last
      character*2 char(100)
      character*2 cha(100)
      integer ifl(20)
      dimension ip(100)
      character*1 a1
      character*2 a2
      character*3 a3
      data init/0/
      
      open(101,file='temporaryfile',status='old')
      read(101,*)numbproc
      read(101,*)n

      allocate(arraysigma(numbproc),array(numbproc),stat=istat)
      if(istat.ne.0)then
        print*,'warning: allocation is not working properly 
     &   in readoutput'
        stop
       endif

      open(102,file='results.output',status='old')
      i=0
      icount=0
      sigmatot=0.0d0
      errortot=0.0d0
      pnevtot=0d0
      lnptot=0
 1    continue
      i=i+1
      read(102,*,end=100)sigma
      arraysigma(i)=sigma
      read(102,*)error
      print'(1P,I6,2E14.6,1I8)',i,sigma,error
      icount=icount+1
      sigmatot=sigmatot+sigma
      errortot=error+errortot
      goto 1
 100  continue

      print*,'sigma(nb)= ',real(sigmatot),'+/-', real(sqrt(errortot))

      do i=1,numbproc
         pnev=arraysigma(i)*100.d0/sigmatot
c     print('(1P,1E14.6,1E12.1)'),arraysigma(i),pnev
         pnevtot=pnevtot+pnev
         array(i)=pnev
      enddo
      
      close(101)
      close(102)

      open(103,file='infile',status='old')
      read(103,*)n1
      read(103,*)(ip(i),i=1,n1)
      nj=0

      do k=1,n1
        if(ip(k).eq.100)then
         nj=nj+1
        endif
      enddo

      np=n1-nj

      do i=1,np
       if(ip(i).eq.1)cha(i)='ve_'
       if(ip(i).eq.-1)cha(i)='ve~'
       if(ip(i).eq.2)cha(i)='e-'
       if(ip(i).eq.-2)cha(i)='e+'
       if(ip(i).eq.5)cha(i)='vm_'
       if(ip(i).eq.-5)cha(i)='vm~'
       if(ip(i).eq.6)cha(i)='m-'
       if(ip(i).eq.-6)cha(i)='m+'
       if(ip(i).eq.9)cha(i)='vT'
       if(ip(i).eq.-9)cha(i)='vT~'
       if(ip(i).eq.10)cha(i)='T-'
       if(ip(i).eq.-10)cha(i)='T+'
       if(ip(i).eq.11)cha(i)='t_'
       if(ip(i).eq.-11)cha(i)='t~'
       if(ip(i).eq.12)cha(i)='b_'
       if(ip(i).eq.-12)cha(i)='b~'
       if(ip(i).eq.31)cha(i)='A_'
       if(ip(i).eq.32)cha(i)='Z_'
       if(ip(i).eq.33)cha(i)='W+'
       if(ip(i).eq.34)cha(i)='W-'
       if(ip(i).eq.41)cha(i)='H0'
      enddo

      print*,'np=',np
      write(process,*)(cha(i),i=1,np)
      write(last,'(i1)')nj
      print*,process(2:2*np+1)
      print*,last
      print*,'numbproc',numbproc
      open(104,file='Pinput'//process(2:2*np+1)//'+'//last//'all')
      open(110,file='cross_sections')
c      print*,'Pinput'//process(2:2*np+1)//'+'//last//'all'
      
      do k=1,numbproc
         print*,'=== process ===',k
         read(104,*)(ifl(i),i=1,n)
         print*,(ifl(i),i=1,n)

       do i=1,n
        if(ifl(i).eq. 2)char(i)='E-'
        if(ifl(i).eq.-2)char(i)='E+'
        if(ifl(i).eq. 1)char(i)='Ne'
        if(ifl(i).eq.-1)char(i)='N1'
        if(ifl(i).eq. 3)char(i)='Uq'
        if(ifl(i).eq.-3)char(i)='Ua'
        if(ifl(i).eq. 4)char(i)='Dq'
        if(ifl(i).eq.-4)char(i)='Da'
        if(ifl(i).eq. 6)char(i)='M-'
        if(ifl(i).eq.-6)char(i)='M+'
        if(ifl(i).eq. 5)char(i)='Nm'
        if(ifl(i).eq.-5)char(i)='N2'
        if(ifl(i).eq. 7)char(i)='Cq'
        if(ifl(i).eq.-7)char(i)='Ca'
        if(ifl(i).eq. 8)char(i)='Sq'
        if(ifl(i).eq.-8)char(i)='Sa'
        if(ifl(i).eq. 10)char(i)='T-'
        if(ifl(i).eq.-10)char(i)='T+'
        if(ifl(i).eq. 9)char(i)='Nt'
        if(ifl(i).eq.-9)char(i)='N3'
        if(ifl(i).eq. 11)char(i)='Tq'
        if(ifl(i).eq.-11)char(i)='Ta'
        if(ifl(i).eq. 12)char(i)='Bq'
        if(ifl(i).eq.-12)char(i)='Ba'
        if(ifl(i).eq.31)char(i)='A0'
        if(ifl(i).eq.32)char(i)='Z0'
        if(ifl(i).eq.33)char(i)='W+'
        if(ifl(i).eq.34)char(i)='W-'
        if(ifl(i).eq.35)char(i)='G0'
        if(ifl(i).eq.41)char(i)='H0'
       enddo

       write(process1,*)(char(i),i=1,n)
       print*,process1(2:2*n+1)
       lnp=array(k)/100d0
       print*,'sigma(',k,') (nb)=',arraysigma(k)
       print*,'rate% =',arraysigma(k)/sigmatot*100
       lnptot=lnp+lnptot
       write(110,*)arraysigma(k)/sigmatot*100       
      enddo

      end

