#!/bin/bash

AFSDIR="$1"
i=$2
DESTINATION=$3

date
echo Entering job $i

mkdir directory_$i

cd directory_$i
cp $AFSDIR/main_mc_dp.exe .
cp $AFSDIR/cinput$i ./input

ln -s $LHAPDFSETS linkPDFsets
ln -s $AFSDIR/cteq6l1.tbl .
ln -s $AFSDIR/seed.input .

main_mc_dp.exe < input > output

rm -f main_mc_dp.exe tmp* fort.*
unlink linkPDFsets
unlink cteq6l1.tbl
unlink seed.input

cd ..

tar zcvf directory_$i.tar.gz directory_$i/*
rfcp directory_$i.tar.gz $DESTINATION

touch dummy$i
rfcp dummy$i $DESTINATION

date
echo Done job $i
