C-----------------------------------------------------------       
      subroutine ktreweight(w)
      include 'declare.h'
      include 'common_int.h'
      include 'common_phegas_mom.h'
      include 'common_unw.h'

      common/clus/icol_cl(20,2),ifl_cl(20),pcl(20,4)
      logical ino(20)

c     print*,'---------------------------------'
c     print*,'NEW EVENT',io(1:n)

      ino(1:20)=.true.
      do i=1,n
       pcl(i,1:4)=pmom(i,1:4)
       icol_cl(i,1:2)=icol_un(i,1:2)
       ifl_cl(i)=mod(ifl(i),35)
       if(abs(ifl(i)).eq.3)ino(i)=.false.
       if(abs(ifl(i)).eq.4)ino(i)=.false.
       if(abs(ifl(i)).eq.7)ino(i)=.false.
       if(abs(ifl(i)).eq.8)ino(i)=.false.
       if(abs(ifl(i)).eq.11)ino(i)=.false.
       if(abs(ifl(i)).eq.12)ino(i)=.false.
       if(abs(ifl(i)).eq.35)ino(i)=.false.
      enddo

      nino=0
      do i=1,n
       if(ino(i))nino=nino+1
      enddo

      np=n
      w=1.0
      
 1    continue
      ifound=0
      i0=0
      j0=0
      dmin=1d13
      if(np.eq.0)return

      do i=1,np-1
       if(ino(i))cycle
c      if(icol_cl(i,1).eq.0.and.icol_cl(i,2).eq.0)cycle
       if1=ifl_cl(i)*io(i)
c      if(abs(if1).eq.35)if1=0
       do j=i+1,np
        if(ino(j))cycle
c       if(icol_cl(j,1).eq.0.and.icol_cl(j,2).eq.0)cycle
        if2=ifl_cl(j)*io(j)
c       if(abs(if2).eq.35)if2=0
        if((if1+if2)*if1*if2.ne.0)cycle
c       if((icol_cl(j,1).eq.icol_cl(i,2).and.icol_cl(i,2).ne.0)
c    . .or.
c    .     (icol_cl(j,2).eq.icol_cl(i,1).and.icol_cl(i,1).ne.0))then
c       if(icol_cl(j,1).eq.icol_cl(i,2).or.
c    ,     icol_cl(j,2).eq.icol_cl(i,1))then
c check color clusterability
        if(icol_cl(i,1).ne.icol_cl(j ,2)
     ..and.icol_cl(i,2).ne.icol_cl(j,1))cycle
         d=dist(i,j)
         if(d.lt.dmin)then
         ifound=1
         i0=i
         j0=j
         dmin=d
         endif
c       endif
       enddo
      enddo

      if(ifound.eq.1.and.np.gt.5)then
       call combine(i0,j0)
       np=np-1
c call weight       
c      scale=90.d0
c      scale2=scale**2
c      print*,'dmin-1',dsqrt(dmin)
c      print*,'2',alphaspdf(dsqrt(dmin))
c      print*,'3',alfas(dmin,0.165d0,1,5)
c      print*,'2',alphas2(dsqrt(dmin))
c      print*,'2',alphaspdf(scale)
c      print*,'3',alfas(scale2,0.165d0,1,5)
c      print*,'2',alphas2(scale)
c      print*,'dmin-2',dsqrt(dmin)
c      w=w*alphas2(dsqrt(dmin))/alphas2(90.d0)
c      w=w*alphaspdf(dsqrt(dmin))/alphaspdf(90.d0)
c      xx=alfas(dmin,0.165d0,1,5)
c      print*,xx
c

c      if(np.gt.4)then
c      if(ifound.eq.1)then
c       print*,Q
        Q=dsqrt(dmin)
        w=w*alphas(Q)/0.118d0 !alphas(scale)
c      elseif(np.eq.4)then
c      else
c       call qcdscale(Q)
c       w=w*alphas(Q)/0.118d0 !alphas(scale)
c       w=w*(alphas(Q)/0.118d0)**(np-4) !alphas(scale)
c       print*,Q,alphas(Q)
c      endif
       if(dmin.lt.0)print*,dmin,w,np,i0,j0
c      w=1
c      print*,'ALPHA_S',alphas2(90.d0**2)
       goto 1
      endif

      call qcdscale(Q)

      npo=np-nino-2
      if(npo.gt.0)w=w*(alphas(Q)/0.118d0)**(npo) !alphas(scale)

      return
      end
 
      function dist(i,j)
      include 'declare.h'
      include 'common_int.h'
      common/clus/icol_cl(20,2),ifl_cl(20),pcl(20,4)

      pt1=pcl(i,1)**2+pcl(i,2)**2
      pt2=pcl(j,1)**2+pcl(j,2)**2
   
c initial-final
      if(io(i).eq. 1.and.io(j).eq.-1)then
       dist=pt2
      endif
c final-initial
      if(io(i).eq.-1.and.io(j).eq. 1)then
       dist=pt1
      endif
c final-final
      if(io(i).eq.-1.and.io(j).eq.-1)then

c      y1=-0.5d0*dlog((pcl(i,4)-pcl(i,3))/(pcl(i,4)+pcl(i,3)))
       p1=dsqrt(pcl(i,1)**2+pcl(i,2)**2+pcl(i,3)**2)
       y1=-0.5d0*dlog((p1-pcl(i,3))/(p1+pcl(i,3)))
c      y2=-0.5d0*dlog((pcl(j,4)-pcl(j,3))/(pcl(j,4)+pcl(j,3)))
       p2=dsqrt(pcl(j,1)**2+pcl(j,2)**2+pcl(j,3)**2)
       y2=-0.5d0*dlog((p2-pcl(j,3))/(p2+pcl(j,3)))

       dphi=(pcl(i,1)*pcl(j,1)+pcl(i,2)*pcl(j,2))/dsqrt(pt1*pt2)
       if(dphi.lt.-1d0.and.dphi.gt.-1d0-1d-6)dphi=-1.d0
       dphi=dacos(dphi)
       dist=min(pt1,pt2)*((y1-y2)**2+dphi**2)
       if(dist.lt.0)print*,i,j,y1,y2,dphi,pt1,pt2
       if(dist.lt.0)print*,i,pcl(i,1:4)
       if(dist.lt.0)print*,j,pcl(j,1:4)
       if(dist.lt.0)print*,io(1:n)
      endif
c initial-initial
      if(io(i).eq. 1.and.io(j).eq. 1)then
       dist=1d14
      endif
c
      return
      end

      subroutine combine(i,j)
      include 'declare.h'
      include 'common_int.h'
      common/clus/icol_cl(20,2),ifl_cl(20),pcl(20,4)
      real*8 p(4)

c     print'(4f12.6)',(pcl(k,1:4),k=1,n)
c     print*,(icol_cl(k,1),k=1,n)
c     print*,(icol_cl(k,2),k=1,n)
c     print*,'------------------'

      i1=min(i,j)
      j1=max(i,j)

      p(1:4)=io(i)*pcl(i,1:4)+io(j)*pcl(j,1:4)
      if(p(4).lt.0)p(1:4)=-p(1:4)

      pcl(i1,1:4)=p(1:4)
      pcl(j1:n-1,1:4)=pcl(j1+1:n,1:4)

      if(icol_cl(i1,1).eq.icol_cl(j1,2))then
       icol_cl(i1,1)=icol_cl(j1,1)
      elseif(icol_cl(i1,2).eq.icol_cl(j1,1))then
       icol_cl(i1,2)=icol_cl(j1,2)
      endif
      if(icol_cl(i1,1).eq.icol_cl(i1,2))icol_cl(i1,1:2)=0
      icol_cl(j1:n-1,1:2)=icol_cl(j1+1:n,1:2)

      if1=ifl_cl(i1)*io(i1)
      if2=ifl_cl(j1)*io(j1)

      if(if1+if2.eq.0)if0=0
      if(if1.eq.0)if0=if2
      if(if2.eq.0)if0=if1

      ifl_cl(i1)=if0
      ifl_cl(j1:n-1)=ifl_cl(j1+1:n)

      return
      end

C-----------------------------------------------------------------------      
      
      FUNCTION ALPHAS(Q)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      include 'alphas.h' 

      return
      end
C-------------------------------------------------------------------
C------- ALPHA QCD -------------------------------------
c Program to calculate alfa strong with nf flavours,
c as a function of lambda with 5 flavors.
c The value of alfa is matched at the thresholds q = mq.
c When invoked with nf < 0 it chooses nf as the number of
c flavors with mass less then q.
c
      function alfas(q2,xlam,nloop,inf)
      implicit real * 8 (a-h,o-z)
      data olam/0.d0/,pi/3.14159d0/
      data xmb/4.5d0/,xmc/1.5d0/
      integer nloop
      save
      if(xlam.ne.olam) then
        olam = xlam
        b5  = (33-2*5)/pi/12
        b4  = (33-2*4)/pi/12
        b3  = (33-2*3)/pi/12
        if(nloop.eq.1) then
           bp5=0
           bp4=0
           bp3=0
        elseif(nloop.eq.2) then
           bp5 = (153 - 19*5) / pi / 2 / (33 - 2*5)
           bp4 = (153 - 19*4) / pi / 2 / (33 - 2*4)
           bp3 = (153 - 19*3) / pi / 2 / (33 - 2*3)
        endif 
        xlc = 2 * log(xmc/xlam)
        xlb = 2 * log(xmb/xlam)
        xllc = log(xlc)
        xllb = log(xlb)
        c45  =  1/( 1/(b5 * xlb) - xllb*bp5/(b5 * xlb)**2 )
     #        - 1/( 1/(b4 * xlb) - xllb*bp4/(b4 * xlb)**2 )
        c35  =  1/( 1/(b4 * xlc) - xllc*bp4/(b4 * xlc)**2 )
     #        - 1/( 1/(b3 * xlc) - xllc*bp3/(b3 * xlc)**2 ) + c45
      endif
      q   = sqrt(q2)
      xlq = 2 * log( q/xlam )
      xllq = log( xlq )
      nf = inf
      if( nf .lt. 0) then
        if( q .gt. xmb ) then
          nf = 5
        elseif( q .gt. xmc ) then
          nf = 4
        else
          nf = 3
        endif
      endif
      if    ( nf .eq. 5 ) then
        alfas = 1/(b5 * xlq) -  bp5/(b5 * xlq)**2 * xllq
      elseif( nf .eq. 4 ) then
        alfas = 1/( 1/(1/(b4 * xlq) - bp4/(b4 * xlq)**2 * xllq) + c45 )
      elseif( nf .eq. 3 ) then
        alfas = 1/( 1/(1/(b3 * xlq) - bp3/(b3 * xlq)**2 * xllq) + c35 )
      else
        print *,'error in alfa: unimplemented # of light flavours',nf
        stop
      endif
      return
      end
c-------------------------------------------
c Program to calculate as with nf flavours
c as a function of lambda with nf flavours
c
      function alfa(q,xlam,nloop,nf)
      data pi/3.14159/
      xlp = float(nloop-1)
      b  = (33-2*nf)/pi/12
      bp = (153 - 19*nf) / pi / 2 / (33 - 2*nf)  * xlp
      t = 2 * log( q/xlam )
      xlt = log( t )
      alfa = 1/(b * t) -  bp/(b * t)**2 * xlt
      return
      end

c----------------------------------------------------------
c Program to get lambda_nf from as_nf at the scale q
c
      function xlambd(as,q,nloop,nf)
      implicit real * 8 (a-h,o-z)
      data pi/3.14159d0/
      xlp = float(nloop-1)
      b  = (33-2*nf)/pi/12
      bp = (153 - 19*nf) / pi / 2 / (33 - 2*nf) * xlp
      t  = 1/b/as
c-----------------------------------------------------------
c Solve the equation
c
    1 xlt = log(t)
      ot = t
c-----------------------------------------------------------
c Solve the equation
c Value and Derivative of alfa with respect to t
c
      as0  = 1/b/t - bp*xlt/(b*t)**2
      as1  = - 1/b/t**2 -bp/b**2*(1-2*xlt)/t**3
      t  = (as-as0)/as1 + t
      if(abs(ot-t)/ot.gt..00001)goto 1
      xlambd = q/exp(t/2)
      return
      end



